diff --git a/buildSrc/version.properties b/buildSrc/version.properties
index 9438c35078b79..df4354a63a729 100644
--- a/buildSrc/version.properties
+++ b/buildSrc/version.properties
@@ -15,7 +15,7 @@ slf4j             = 1.6.2
 # when updating the JNA version, also update the version in buildSrc/build.gradle
 jna               = 4.5.1
 
-netty             = 4.1.31.Final
+netty             = 4.1.32.Final
 joda              = 2.10.1
 
 # test dependencies
diff --git a/modules/transport-netty4/build.gradle b/modules/transport-netty4/build.gradle
index afa82e015860c..d84c308294e23 100644
--- a/modules/transport-netty4/build.gradle
+++ b/modules/transport-netty4/build.gradle
@@ -109,6 +109,8 @@ thirdPartyAudit.excludes = [
         'org.jboss.marshalling.Unmarshaller',
 
         // from io.netty.util.internal.logging.InternalLoggerFactory (netty) - it's optional
+        'org.slf4j.helpers.FormattingTuple',
+        'org.slf4j.helpers.MessageFormatter',
         'org.slf4j.Logger',
         'org.slf4j.LoggerFactory',
         'org.slf4j.spi.LocationAwareLogger',
diff --git a/modules/transport-netty4/licenses/netty-buffer-4.1.31.Final.jar.sha1 b/modules/transport-netty4/licenses/netty-buffer-4.1.31.Final.jar.sha1
deleted file mode 100644
index 22b58c5241485..0000000000000
--- a/modules/transport-netty4/licenses/netty-buffer-4.1.31.Final.jar.sha1
+++ /dev/null
@@ -1 +0,0 @@
-e086523d6bb01fcab1d8dd370eecfcd606311b92
\ No newline at end of file
diff --git a/modules/transport-netty4/licenses/netty-buffer-4.1.32.Final.jar.sha1 b/modules/transport-netty4/licenses/netty-buffer-4.1.32.Final.jar.sha1
new file mode 100644
index 0000000000000..111093792d347
--- /dev/null
+++ b/modules/transport-netty4/licenses/netty-buffer-4.1.32.Final.jar.sha1
@@ -0,0 +1 @@
+046ede57693788181b2cafddc3a5967ed2f621c8
\ No newline at end of file
diff --git a/modules/transport-netty4/licenses/netty-codec-4.1.31.Final.jar.sha1 b/modules/transport-netty4/licenses/netty-codec-4.1.31.Final.jar.sha1
deleted file mode 100644
index 83e6eab1261c2..0000000000000
--- a/modules/transport-netty4/licenses/netty-codec-4.1.31.Final.jar.sha1
+++ /dev/null
@@ -1 +0,0 @@
-cfa60b136f5ea57787e910eee37e240bb45402a7
\ No newline at end of file
diff --git a/modules/transport-netty4/licenses/netty-codec-4.1.32.Final.jar.sha1 b/modules/transport-netty4/licenses/netty-codec-4.1.32.Final.jar.sha1
new file mode 100644
index 0000000000000..5830dd05a5027
--- /dev/null
+++ b/modules/transport-netty4/licenses/netty-codec-4.1.32.Final.jar.sha1
@@ -0,0 +1 @@
+8f32bd79c5a16f014a4372ed979dc62b39ede33a
\ No newline at end of file
diff --git a/modules/transport-netty4/licenses/netty-codec-http-4.1.31.Final.jar.sha1 b/modules/transport-netty4/licenses/netty-codec-http-4.1.31.Final.jar.sha1
deleted file mode 100644
index b6d43d380ac17..0000000000000
--- a/modules/transport-netty4/licenses/netty-codec-http-4.1.31.Final.jar.sha1
+++ /dev/null
@@ -1 +0,0 @@
-bf6321b3f10ea3aefc1970b30bb8928e833f236c
\ No newline at end of file
diff --git a/modules/transport-netty4/licenses/netty-codec-http-4.1.32.Final.jar.sha1 b/modules/transport-netty4/licenses/netty-codec-http-4.1.32.Final.jar.sha1
new file mode 100644
index 0000000000000..6ff945b6c2de4
--- /dev/null
+++ b/modules/transport-netty4/licenses/netty-codec-http-4.1.32.Final.jar.sha1
@@ -0,0 +1 @@
+0b9218adba7353ad5a75fcb639e4755d64bd6ddf
\ No newline at end of file
diff --git a/modules/transport-netty4/licenses/netty-common-4.1.31.Final.jar.sha1 b/modules/transport-netty4/licenses/netty-common-4.1.31.Final.jar.sha1
deleted file mode 100644
index 1c0c67721e22d..0000000000000
--- a/modules/transport-netty4/licenses/netty-common-4.1.31.Final.jar.sha1
+++ /dev/null
@@ -1 +0,0 @@
-39ddfa47808c8393a343513571e404fef02f45f0
\ No newline at end of file
diff --git a/modules/transport-netty4/licenses/netty-common-4.1.32.Final.jar.sha1 b/modules/transport-netty4/licenses/netty-common-4.1.32.Final.jar.sha1
new file mode 100644
index 0000000000000..02dd7ce15b843
--- /dev/null
+++ b/modules/transport-netty4/licenses/netty-common-4.1.32.Final.jar.sha1
@@ -0,0 +1 @@
+e95de4f762606f492328e180c8ad5438565a5e3b
\ No newline at end of file
diff --git a/modules/transport-netty4/licenses/netty-handler-4.1.31.Final.jar.sha1 b/modules/transport-netty4/licenses/netty-handler-4.1.31.Final.jar.sha1
deleted file mode 100644
index c344af3b70a7e..0000000000000
--- a/modules/transport-netty4/licenses/netty-handler-4.1.31.Final.jar.sha1
+++ /dev/null
@@ -1 +0,0 @@
-7703c0696f2f34ec7c223c6a5750366a5f4dfb6f
\ No newline at end of file
diff --git a/modules/transport-netty4/licenses/netty-handler-4.1.32.Final.jar.sha1 b/modules/transport-netty4/licenses/netty-handler-4.1.32.Final.jar.sha1
new file mode 100644
index 0000000000000..06af1850f8cca
--- /dev/null
+++ b/modules/transport-netty4/licenses/netty-handler-4.1.32.Final.jar.sha1
@@ -0,0 +1 @@
+b4e3fa13f219df14a9455cc2111f133374428be0
\ No newline at end of file
diff --git a/modules/transport-netty4/licenses/netty-resolver-4.1.31.Final.jar.sha1 b/modules/transport-netty4/licenses/netty-resolver-4.1.31.Final.jar.sha1
deleted file mode 100644
index f6d72804412c2..0000000000000
--- a/modules/transport-netty4/licenses/netty-resolver-4.1.31.Final.jar.sha1
+++ /dev/null
@@ -1 +0,0 @@
-8ea7a47400beedd5bb901b96a0730eea8b7b6f2a
\ No newline at end of file
diff --git a/modules/transport-netty4/licenses/netty-resolver-4.1.32.Final.jar.sha1 b/modules/transport-netty4/licenses/netty-resolver-4.1.32.Final.jar.sha1
new file mode 100644
index 0000000000000..58d0dfb949c4c
--- /dev/null
+++ b/modules/transport-netty4/licenses/netty-resolver-4.1.32.Final.jar.sha1
@@ -0,0 +1 @@
+3e0114715cb125a12db8d982b2208e552a91256d
\ No newline at end of file
diff --git a/modules/transport-netty4/licenses/netty-transport-4.1.31.Final.jar.sha1 b/modules/transport-netty4/licenses/netty-transport-4.1.31.Final.jar.sha1
deleted file mode 100644
index e44515c5e8f65..0000000000000
--- a/modules/transport-netty4/licenses/netty-transport-4.1.31.Final.jar.sha1
+++ /dev/null
@@ -1 +0,0 @@
-e3396bd65e9c76accac11c29dca035da1cc39cb1
\ No newline at end of file
diff --git a/modules/transport-netty4/licenses/netty-transport-4.1.32.Final.jar.sha1 b/modules/transport-netty4/licenses/netty-transport-4.1.32.Final.jar.sha1
new file mode 100644
index 0000000000000..b248610a88623
--- /dev/null
+++ b/modules/transport-netty4/licenses/netty-transport-4.1.32.Final.jar.sha1
@@ -0,0 +1 @@
+d5e5a8ff9c2bc7d91ddccc536a5aca1a4355bd8b
\ No newline at end of file
diff --git a/modules/transport-netty4/src/main/java/org/elasticsearch/transport/netty4/Netty4Utils.java b/modules/transport-netty4/src/main/java/org/elasticsearch/transport/netty4/Netty4Utils.java
index ad216f8ff2cf7..35928b6c3c8a2 100644
--- a/modules/transport-netty4/src/main/java/org/elasticsearch/transport/netty4/Netty4Utils.java
+++ b/modules/transport-netty4/src/main/java/org/elasticsearch/transport/netty4/Netty4Utils.java
@@ -107,9 +107,14 @@ public static ByteBuf toByteBuf(final BytesReference reference) {
                 while ((slice = iterator.next()) != null) {
                     buffers.add(Unpooled.wrappedBuffer(slice.bytes, slice.offset, slice.length));
                 }
-                final CompositeByteBuf composite = Unpooled.compositeBuffer(buffers.size());
-                composite.addComponents(true, buffers);
-                return composite;
+
+                if (buffers.size() == 1) {
+                    return buffers.get(0);
+                } else {
+                    CompositeByteBuf composite = Unpooled.compositeBuffer(buffers.size());
+                    composite.addComponents(true, buffers);
+                    return composite;
+                }
             } catch (IOException ex) {
                 throw new AssertionError("no IO happens here", ex);
             }
diff --git a/plugins/transport-nio/build.gradle b/plugins/transport-nio/build.gradle
index 2287fd683f8c0..c671eaac3f037 100644
--- a/plugins/transport-nio/build.gradle
+++ b/plugins/transport-nio/build.gradle
@@ -88,6 +88,8 @@ thirdPartyAudit.excludes = [
         'org.jboss.marshalling.Unmarshaller',
 
         // from io.netty.util.internal.logging.InternalLoggerFactory (netty) - it's optional
+        'org.slf4j.helpers.FormattingTuple',
+        'org.slf4j.helpers.MessageFormatter',
         'org.slf4j.Logger',
         'org.slf4j.LoggerFactory',
         'org.slf4j.spi.LocationAwareLogger',
diff --git a/plugins/transport-nio/licenses/netty-buffer-4.1.31.Final.jar.sha1 b/plugins/transport-nio/licenses/netty-buffer-4.1.31.Final.jar.sha1
deleted file mode 100644
index 22b58c5241485..0000000000000
--- a/plugins/transport-nio/licenses/netty-buffer-4.1.31.Final.jar.sha1
+++ /dev/null
@@ -1 +0,0 @@
-e086523d6bb01fcab1d8dd370eecfcd606311b92
\ No newline at end of file
diff --git a/plugins/transport-nio/licenses/netty-buffer-4.1.32.Final.jar.sha1 b/plugins/transport-nio/licenses/netty-buffer-4.1.32.Final.jar.sha1
new file mode 100644
index 0000000000000..111093792d347
--- /dev/null
+++ b/plugins/transport-nio/licenses/netty-buffer-4.1.32.Final.jar.sha1
@@ -0,0 +1 @@
+046ede57693788181b2cafddc3a5967ed2f621c8
\ No newline at end of file
diff --git a/plugins/transport-nio/licenses/netty-codec-4.1.31.Final.jar.sha1 b/plugins/transport-nio/licenses/netty-codec-4.1.31.Final.jar.sha1
deleted file mode 100644
index 83e6eab1261c2..0000000000000
--- a/plugins/transport-nio/licenses/netty-codec-4.1.31.Final.jar.sha1
+++ /dev/null
@@ -1 +0,0 @@
-cfa60b136f5ea57787e910eee37e240bb45402a7
\ No newline at end of file
diff --git a/plugins/transport-nio/licenses/netty-codec-4.1.32.Final.jar.sha1 b/plugins/transport-nio/licenses/netty-codec-4.1.32.Final.jar.sha1
new file mode 100644
index 0000000000000..5830dd05a5027
--- /dev/null
+++ b/plugins/transport-nio/licenses/netty-codec-4.1.32.Final.jar.sha1
@@ -0,0 +1 @@
+8f32bd79c5a16f014a4372ed979dc62b39ede33a
\ No newline at end of file
diff --git a/plugins/transport-nio/licenses/netty-codec-http-4.1.31.Final.jar.sha1 b/plugins/transport-nio/licenses/netty-codec-http-4.1.31.Final.jar.sha1
deleted file mode 100644
index b6d43d380ac17..0000000000000
--- a/plugins/transport-nio/licenses/netty-codec-http-4.1.31.Final.jar.sha1
+++ /dev/null
@@ -1 +0,0 @@
-bf6321b3f10ea3aefc1970b30bb8928e833f236c
\ No newline at end of file
diff --git a/plugins/transport-nio/licenses/netty-codec-http-4.1.32.Final.jar.sha1 b/plugins/transport-nio/licenses/netty-codec-http-4.1.32.Final.jar.sha1
new file mode 100644
index 0000000000000..6ff945b6c2de4
--- /dev/null
+++ b/plugins/transport-nio/licenses/netty-codec-http-4.1.32.Final.jar.sha1
@@ -0,0 +1 @@
+0b9218adba7353ad5a75fcb639e4755d64bd6ddf
\ No newline at end of file
diff --git a/plugins/transport-nio/licenses/netty-common-4.1.31.Final.jar.sha1 b/plugins/transport-nio/licenses/netty-common-4.1.31.Final.jar.sha1
deleted file mode 100644
index 1c0c67721e22d..0000000000000
--- a/plugins/transport-nio/licenses/netty-common-4.1.31.Final.jar.sha1
+++ /dev/null
@@ -1 +0,0 @@
-39ddfa47808c8393a343513571e404fef02f45f0
\ No newline at end of file
diff --git a/plugins/transport-nio/licenses/netty-common-4.1.32.Final.jar.sha1 b/plugins/transport-nio/licenses/netty-common-4.1.32.Final.jar.sha1
new file mode 100644
index 0000000000000..02dd7ce15b843
--- /dev/null
+++ b/plugins/transport-nio/licenses/netty-common-4.1.32.Final.jar.sha1
@@ -0,0 +1 @@
+e95de4f762606f492328e180c8ad5438565a5e3b
\ No newline at end of file
diff --git a/plugins/transport-nio/licenses/netty-handler-4.1.31.Final.jar.sha1 b/plugins/transport-nio/licenses/netty-handler-4.1.31.Final.jar.sha1
deleted file mode 100644
index c344af3b70a7e..0000000000000
--- a/plugins/transport-nio/licenses/netty-handler-4.1.31.Final.jar.sha1
+++ /dev/null
@@ -1 +0,0 @@
-7703c0696f2f34ec7c223c6a5750366a5f4dfb6f
\ No newline at end of file
diff --git a/plugins/transport-nio/licenses/netty-handler-4.1.32.Final.jar.sha1 b/plugins/transport-nio/licenses/netty-handler-4.1.32.Final.jar.sha1
new file mode 100644
index 0000000000000..06af1850f8cca
--- /dev/null
+++ b/plugins/transport-nio/licenses/netty-handler-4.1.32.Final.jar.sha1
@@ -0,0 +1 @@
+b4e3fa13f219df14a9455cc2111f133374428be0
\ No newline at end of file
diff --git a/plugins/transport-nio/licenses/netty-resolver-4.1.31.Final.jar.sha1 b/plugins/transport-nio/licenses/netty-resolver-4.1.31.Final.jar.sha1
deleted file mode 100644
index f6d72804412c2..0000000000000
--- a/plugins/transport-nio/licenses/netty-resolver-4.1.31.Final.jar.sha1
+++ /dev/null
@@ -1 +0,0 @@
-8ea7a47400beedd5bb901b96a0730eea8b7b6f2a
\ No newline at end of file
diff --git a/plugins/transport-nio/licenses/netty-resolver-4.1.32.Final.jar.sha1 b/plugins/transport-nio/licenses/netty-resolver-4.1.32.Final.jar.sha1
new file mode 100644
index 0000000000000..58d0dfb949c4c
--- /dev/null
+++ b/plugins/transport-nio/licenses/netty-resolver-4.1.32.Final.jar.sha1
@@ -0,0 +1 @@
+3e0114715cb125a12db8d982b2208e552a91256d
\ No newline at end of file
diff --git a/plugins/transport-nio/licenses/netty-transport-4.1.31.Final.jar.sha1 b/plugins/transport-nio/licenses/netty-transport-4.1.31.Final.jar.sha1
deleted file mode 100644
index e44515c5e8f65..0000000000000
--- a/plugins/transport-nio/licenses/netty-transport-4.1.31.Final.jar.sha1
+++ /dev/null
@@ -1 +0,0 @@
-e3396bd65e9c76accac11c29dca035da1cc39cb1
\ No newline at end of file
diff --git a/plugins/transport-nio/licenses/netty-transport-4.1.32.Final.jar.sha1 b/plugins/transport-nio/licenses/netty-transport-4.1.32.Final.jar.sha1
new file mode 100644
index 0000000000000..b248610a88623
--- /dev/null
+++ b/plugins/transport-nio/licenses/netty-transport-4.1.32.Final.jar.sha1
@@ -0,0 +1 @@
+d5e5a8ff9c2bc7d91ddccc536a5aca1a4355bd8b
\ No newline at end of file
diff --git a/plugins/transport-nio/src/main/java/org/elasticsearch/http/nio/ByteBufUtils.java b/plugins/transport-nio/src/main/java/org/elasticsearch/http/nio/ByteBufUtils.java
index b4108b3e6c7d0..8f2908eae8563 100644
--- a/plugins/transport-nio/src/main/java/org/elasticsearch/http/nio/ByteBufUtils.java
+++ b/plugins/transport-nio/src/main/java/org/elasticsearch/http/nio/ByteBufUtils.java
@@ -54,9 +54,14 @@ static ByteBuf toByteBuf(final BytesReference reference) {
                 while ((slice = iterator.next()) != null) {
                     buffers.add(Unpooled.wrappedBuffer(slice.bytes, slice.offset, slice.length));
                 }
-                final CompositeByteBuf composite = Unpooled.compositeBuffer(buffers.size());
-                composite.addComponents(true, buffers);
-                return composite;
+
+                if (buffers.size() == 1) {
+                    return buffers.get(0);
+                } else {
+                    CompositeByteBuf composite = Unpooled.compositeBuffer(buffers.size());
+                    composite.addComponents(true, buffers);
+                    return composite;
+                }
             } catch (IOException ex) {
                 throw new AssertionError("no IO happens here", ex);
             }
diff --git a/x-pack/plugin/security/src/test/java/org/elasticsearch/xpack/security/transport/ssl/SslIntegrationTests.java b/x-pack/plugin/security/src/test/java/org/elasticsearch/xpack/security/transport/ssl/SslIntegrationTests.java
index 20f15577b8adc..c147c660b74a4 100644
--- a/x-pack/plugin/security/src/test/java/org/elasticsearch/xpack/security/transport/ssl/SslIntegrationTests.java
+++ b/x-pack/plugin/security/src/test/java/org/elasticsearch/xpack/security/transport/ssl/SslIntegrationTests.java
@@ -95,8 +95,6 @@ public void testThatUnconfiguredCiphersAreRejected() throws Exception {
         }
     }
 
-    // no SSL exception as this is the exception is returned when connecting
-    @AwaitsFix(bugUrl = "https://github.com/elastic/elasticsearch/issues/35360")
     public void testThatTransportClientUsingSSLv3ProtocolIsRejected() {
         assumeFalse("Can't run in a FIPS JVM as SSLv3 SSLContext not available", inFipsJvm());
         try (TransportClient transportClient = new TestXPackTransportClient(Settings.builder()
